<template lang="pug">
.form
	.field
		label.label.is-large {{$t("form.images")}}
	.field
		b-drop( v-model='files' )
			.file-cta
				.file-icon
					i.fa-solid.fa-upload
				.file-label.has-text-centered {{$t("form.choose_files")}}
	.field
		draggable.drag(
			v-if='files.length > 0'
			:list='files'
			handle=".drag")
			.wrapper.is-relative( v-for='(file, i) in files' :key='i' )
				.icons.is-absolute
					span.icon.is-small.has-text-white.drag
						i.fa-solid.fa-arrows-up-down-left-right.fa-xs
					span.icon.has-text-danger.remove( @click='remove(i)' )
						i.fa-solid.fa-xmark.fa-xs
				img( :src='u(file)' crossorigin="use-credentials" )
</template>

<script setup>
import { VueDraggableNext as draggable } from "vue-draggable-next"
import BDrop from "@/components/form/Drop.vue"

import { computed, onMounted, ref, watch } from "vue"

const emit = defineEmits(["update:modelValue"])
const props = defineProps({ modelValue: Object })

const modelValue = computed(() => props.modelValue)
const files = ref(modelValue.value || [])

const url = `//${import.meta.env.VITE_API_URI}`
const u = file => file.lastModified ? URL.createObjectURL(file) : `${url}/cars/${file.name}_480.webp`
const remove = i => files.value.splice(i, 1)
const update = () => emit("update:modelValue", files.value)

watch(() => [ ...files.value ], nv => emit("update:modelValue", nv))

onMounted(update)
</script>

<style lang="scss" scoped>
@import "bulma/sass/utilities/all";

.form {
	width: 100%;
}
.field {
	width: 100%;
	&:deep(.upload) {
		width: 100%;
		.upload-draggable,
		.file-cta {
			width: 100%;
		}
	}
}

.drag {
	display: flex;
	align-items: center;
	justify-content: flex-start;
	flex-wrap: wrap;
	.wrapper {
		width: 32%;
		margin: 0 1% 1% 0;

		.icons {
			display: flex;
			align-items: center;
			justify-content: flex-end;
			position: absolute;
			top: .25rem;
			right: .25rem;
			.icon {
				display: flex;
				align-items: center;
				justify-content: center;
				border-radius: 50%;
				&+.icon {
					margin-left: .25rem;
				}
				&.drag {
					background: $dark;
					cursor: grab;
					&:deep(svg) {
						font-size: .55rem;
					}
				}
				&.remove {
					cursor: pointer;
				}

				svg {
					user-select: none;
					pointer-events: none;
				}
			}
		}

		img {
			width: 100%;
		}
	}
}
</style>